package com.processmininguc.feedbackrepair.models;

import javax.swing.JComponent;

import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.heuristics.HeuristicsNet;
import org.processmining.models.heuristics.impl.HNSet;

@Plugin(name = "Feedback Repair Visualizer", parameterLabels = { "FeedbackRepair" }, returnLabels = { "Feedback enhanced Heuristic Net" }, returnTypes = { JComponent.class })
@Visualizer
public class FeedbackRepairVisualization {
	
	@PluginVariant(requiredParameterLabels = { 0 })
	public static JComponent visualize(PluginContext context, final FeedbackRepair fr) {
		
		final JComponent graphPanel = fr.getGraphPanel(context);
		final HeuristicsNet net = fr.getNet();
		System.out.println("Tamaño: " + net.size());
		HNSet[] inputSets = net.getInputSets();
		HNSet[] outputSets = net.getOutputSets();
		
		System.out.println("--------- Input sets ---------");
		for(int i = 0; i < net.size(); i++) {
			System.out.println("Input set " + i + ": " + net.getInputSet(i).toString());
		}
		System.out.println("--------- Output sets ---------");
		for(int i = 0; i < net.size(); i++) {
			System.out.println("Output set " + i + ": " + net.getOutputSet(i).toString());
		}
		return graphPanel;
	}

}
